gnutls_certificate_set_x509_key_mem(3)

NAME
gnutls_certificate_set_x509_key_mem - Used to set keys in a gnutls_certificate_credentials_t structure

SYNOPSIS
#include <gnutls/gnutls.h>

int gnutls_certificate_set_x509_key_mem(gnutls_certificate_credentials_t res, const gnutls_datum_t * cert, const gnutls_datum_t * key, gnutls_x509_crt_fmt_t type);

ARGUMENTS

gnutls_certificate_credentials_t          res
    is an gnutls_certificate_credentials_t structure.

const gnutls_datum_t * cert
    contains a certificate list (path) for the specified private key

const gnutls_datum_t * key
    is the private key

gnutls_x509_crt_fmt_t type
    is PEM or DER

DESCRIPTION
This function sets a certificate/private key pair in the gnutls_certificate_credentials_t structure. This function may be called more than once (in case multiple keys/certificates exist for the server).

CURRENTLY ARE SUPPORTED
RSA PKCS-1 encoded private keys, DSA private keys. DSA private keys are encoded the OpenSSL way, which is an ASN.1 DER sequence of 6 INTEGERs - version, p, q, g, pub, priv. Note that the keyUsage (2.5.29.15) PKIX extension in X.509 certificates is supported. This means that certificates intended for signing cannot be used for ciphersuites that require encryption. If the certificate and the private key are given in PEM encoding then the strings that hold their values must be null terminated.

REPORTING BUGS
Report bugs to <bug-gnutls@gnu.org>.

COPYRIGHT
Copyright © 2004 Free Software Foundation.
Permission is granted to make and distribute verbatim copies of this manual provided the copyright notice and this permission notice are preserved on all copies.

SEE ALSO
The full documentation for gnutls is maintained as a Texinfo manual. If the info and gnutls programs are properly installed at your site, the command

    info gnutls

should give you access to the complete manual.